<!DOCTYPE html>
<html>

<head>
    <title>Box model</title>
    <html lang="fr">
    <meta charset="utf-8" />
    <link rel="stylesheet" type="text/css" href="../css/Boxstyle.css" />
    <!--va chercher le fichier CSS-->
</head>

<body>
        <nav>
				<h2 class="navigation flexnav">
					<p><a href="index.html">Balises HTML </a></p>
					<p><a href="TextCSS.html">Mise en forme du texte </a></p>
					<p><a href="Boxmodel.html">Mise en forme des boites </a></p>
					<p><a href="Formulaires.html">Formulaires </a></p>
					<p><a href="JavaScript.html">JavaScript </a></p>
					<p><a href="Illustrations.html">Illustrations </a></p>
				</h2>
				
			</nav>
    <header>
        <!-- entete de la page, remplace <div id="header"> en HTML4-->
        <h1>Travailler avec des boites</h1>
    </header>

    <nav>
        <h2 style="font-size: medium;" class="flex">
            <p><a href="#intro">Introduction</a></p>
            <p><a href="#fond">Le fond</a></p>
            <p><a href="#bord">Le bord</a></p>
            <p><a href="#ombre">l'ombre</a></p>
            <p><a href="#position">La position</a></p>
            <p><a href="#flexbox">Le flexbox</a></p>
            <p><a href="#transformation">Les transformations</a></p>
            <p><a href="#transition">Les transitions</a>
                <p><a href="#animation">Les animations</a></p>
        </h2>
        <div class="cours">Cette page est un aide mémoire pour comprendre et appliquer les différentes propriétés des
            boites. L'idéal est de la suivre avec le code HTML et CSS pour les modifier et en voir les effets.</div>
        <p>Sur cette page, tous les éléments auront un fond et un bord pour voir les effets : en bleu pour les
            indications, en jaune pour les exemples et les exercices.</p>
    </nav>
    <article>
        <!--introduction-->
        <h2 id="intro">Qu'est ce qu'une boite</h2>
        <div class="cours">Tout élement HTML de type "block"* peut être considéré comme une boite. Celle-ci comporte :
            <ul>
                <li>un contenu (ce texte),</li>
                <li>une marge interieure (padding : ne se voit pas, est de la meme couleur que le contenu),</li>
                <li>une bordure (border)</li>
                <li>la marge extérieure (margin: ne se voit pas, est de la même couleur que l'élément exterieur - ici,
                    la page blanche).</li>
            </ul>* <small>les autres sont des éléments "inline" comme span, strong, img, a... qu'on peut transformer en
                boite avec "display".</small></div>
        <div id="margin">margin<div id="border">border<div id="padding">padding<p id="contenu">contenu</p>padding</div>border</div>margin</div>

        <div class="cours">On va pouvoir définir leurs dimensions :<ul>
                <li> le contenu par sa largeur (width) et sa hauteur (height). Par défaut, la largeur fait toute la
                    page (100%) et la hauteur s'adapte au nombre de lignes.</li>
                <li> le padding est défini par 4 valeurs, dans l'ordre top, right, bottom, left. S'il y a une seule
                    valeur elle s'applique à tout le tour.</li>
                <li>la bordure (border) est définie par son épaisseur "width" (4 valeurs, sur le même principe), mais
                    aussi son "style" et sa couleur.</li>
                <li> le margin est défini par 4 valeurs, dans l'ordre top, right, bottom, left.</li>
            </ul>ATTENTION : par défaut, margin n'est pas = 0, mais dépend des navigateurs. Pour l'annuler : "*
            {margin:0; padding:0;}" dans le css.</div>
        <div class="boite1">voici une boite 1 réalisée avec l'élément div.<p class="boite2">Voici une boite 2 réalisée
                avec l'élément p, située dans la boite div. Avec les propriétés width (largeur) et height (hauteur),
                elle dépasse son contenant (ce qu'il faut veiller à ne pas faire). </p> ici c'est toujours ma boite 1.</div>

        <div class="cours">La largeur d'une boite sera calculée en ajoutant à la largeur du contenu: <ul>
                <li>le padding droit + le padding gauche,</li>
                <li>la bordure droite + la bordure gauche</li>
                <li>le margin droit + le margin gauche.</li>
            </ul>Idem pour calculer la hauteur. <br />On peut déterminer des dimensions minimum et maximum de la boite
            avec :<ul>
                <li>min-width</li>
                <li>max-width</li>
                <li>min-height</li>
                <li>max-height</li>
            </ul>Les dimensions s'expriment en pixels (px) ou en % (surtout pour la largeur).</div>
        <p class="taille1">minimum : width = 500px ; height = 150px</p>
        <p class="taille2">maximum : 150px*150px</p>
        <p class="carre">fixé : 150px*150px</p>
        <br class="clearing" />
        <div class="cours">Quand les dimensions sont fixées, le texte risque de dépasser de la boite. On peut le gérer
            avec la propriété "overflow". Celle ci peut prendre les valeurs : <ul>
                <li>"visible" (valeur par défaut) = le texte déborde</li>
                <li>"scroll" = pose un ascenseur horizontal et vertical selon les besoins</li>
                <li>"hidden" = cache le texte</li>
                <li>"auto" = ici, fait comme scroll.</li>
            </ul>
        </div>
        <p class="carre overflow1">visible<br />Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed non risus.
            Suspendisse lectus tortor, dignissim sit amet, adipiscing nec, ultricies sed, dolor.</p>
        <p class="carre overflow2">scroll<br />Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed non risus.
            Suspendisse lectus tortor, dignissim sit amet, adipiscing nec, ultricies sed, dolor. Cras elementum
            ultrices diam. Maecenas ligula massa, varius a, semper congue, euismod non, mi. Proin porttitor, orci nec
            nonummy molestie, enim est eleifend mi, non fermentum diam nisl sit amet erat.
            Supercalifragilisticexpialidocious.</p>
        <p class="carre overflow3">hidden<br />Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed non risus.
            Suspendisse lectus tortor, dignissim sit amet, adipiscing nec, ultricies sed, dolor. Cras elementum
            ultrices diam. Maecenas ligula massa, varius a, semper congue, euismod non, mi. Proin porttitor, orci nec
            nonummy molestie, enim est eleifend mi, non fermentum diam nisl sit amet erat.</p>
        <p class="carre overflow4">auto<br />Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed non risus.
            Suspendisse lectus tortor, dignissim sit amet, adipiscing nec, ultricies sed, dolor. Cras elementum
            ultrices diam. Maecenas ligula massa, varius a, semper congue, euismod non, mi. Proin porttitor, orci nec
            nonummy molestie, enim est eleifend mi, non fermentum diam nisl sit amet erat.
            Supercalifragilisticexpialidocious</p>
        <br class="clearing" />
        <hr />
        <!--décorer le fond des boites-->
        <h2 id="fond">Mettre de la couleur au fond des boites</h2>
        <div class="cours">La couleur d'un fond fonctionne avec la propriété "background-color". Elle peut être
            dégradée de façon linéaire avec "linear-gradient" : de haut en bas (par défaut) ou toute autre direction en
            l'indiquant avec un degré d'angle "180deg" est la valeur par défaut, "90deg" va de gauche à droite, "0deg"
            de bas en haut, "270deg" de droite à gauche... (le mieux car plus simple dans leur déclinaison) ou les
            valeurs "left", "right", ""top", "bottom" seules ou conjuguées pour une diagonale (à éviter) <br />
            ATTENTION, cette propriété doit être déclinée pour être lisible par tous les navigateurs (voir le code des
            exemples).<br /> Enfin, la transition entre les couleurs peut être indiquée en % ou en pixels.</div>
        <p class="degrad1">La couleur (jaune-aqua-rouge) est dégradée ici de façon linéaire, avec "linear-gradient", de
            gauche à droite.</p>
        <p class="degrad2">La couleur (jaune50%-aqua60%-rouge70%) avec des indications de transition des couleurs.
            ATTENTION les chiffres sont progressifs</p>
        <p class="degrad3">La couleur (jaune-aqua-rouge) est dégradée en répétant l'effet avec
            "background:-moz-repeating-linear-gradient".</p>
        <p class="degradiag">Encore un essai, avec un dégradé en diagonal, avec un effet de transparence rouge.</p>
        <div class="cours">La propriété "background-color" peut aussi être dégradée de façon circulaire avec
            "radial-gradient" en précisant la forme elliptique (par défaut, mais si la boite est un carré = cercle) ou
            circulaire "circle", la position (par rapport à la gauche, puis par rapport au haut) et la taille du
            dégradé : il existe pour cela des mots clés : <ul>
                <li>closest-side : le dégradé va toucher le coté le plus proche de son centre (les 2 cotés dans le cas
                    d'une ellipse)</li>
                <li>farthest-side : le dégradé va toucher le coté le plus éloigné de son centre (les 2 cotés dans le
                    cas d'une ellipse)</li>
                <li>closest-corner : le dégradé va toucher le coin le plus proche de son centre</li>
                <li>farthest-corner : le dégradé va toucher le coin le plus éloigné de son centre</li>
            </ul>ATTENTION, cette propriété doit aussi être déclinée pour être lisible par tous les navigateurs (voir
            le code des exemples).</div>
        <p class="carre radial1">Essai avec radial gradient (circle, yellow, aqua, red)</p>
        <p class="carre radial2">Essai avec des transitions entre les couleurs (circle, yellow 50%, aqua 60%, red 70%)</p>
        <p class="carre radial3">Essai avec les valeurs closest-side, farthest-side, closest-corner et farthest-corner
        </p>
        <p class="rectangle radial4">Essai sur un rectangle</p>
        <br class="clearing" />

        <div class="cours">Le fond peut être une image à insérer avec background-image, et à adapter en taille avec
            background-size : soit un % (indique la place que doit occuper l'élément dans la boite), des pixels, ou un
            mot clé comme "cover" (permet de la mettre en entier avec un bout caché, alors que 100% fera apparaitre une
            répétition au cas ou l'image ne soit pas strictement égale au cadre), "auto"... <br />"backgroung-repeat"
            permet de répéter l'image avec les valeurs "repeat"(= par défaut), "repeat-x", "repeat-y", "no-repeat".</div>
        <p class="carre image bgimg1"></p>
        <p class="carre image bgimg2"></p>
        <p class="rectangle image bgimg3"></p>
        <p class="rond image bgimg4"></p><br />

        <div class="cours clearing">Centrer verticalement une image de taille variable dans un conteneur de hauteur
            fixe</div>
        <p class="alignv"> <img class="alignv1" src="../Images/cat.jpg" alt="" width="200px" /> </p>

        <!--<br class="clearing" />-->


        <hr />
        <!--pour s'entrainer a décorer le bord des boites-->
        <h2 id="bord">Décorer le bord des boites</h2>
        <div class="cours">La bordure peut varier avec la propriété "border-style", dont on peut voir les différentes
            valeurs ci dessous. Son épaisseur peut être déterminée par "border-width".</div>
        <p class="none">This paragraph has no border.</p>
        <p class="dotted">This is a dotted border.</p>
        <p class="dashed">This is a dashed border.</p>
        <p class="double">This is a double border.</p>
        <p class="groove">This is a grooved border. Cela ajoute un effet 3D.</p>
        <p class="ridge">This is a ridged border. Cela ajoute un effet 3D.</p>
        <p class="inset">This is an inset border. Cela ajoute un effet 3D.</p>
        <p class="outset">This is an outset border. Cela ajoute un effet 3D.</p>
        <p class="hidden">This is a hidden border.</p>
        <p class="inherit">Paragraphe avec la valeur "inherit" attribuée au bord et au fond (donc celle de "article"</p>
        <div class="cours">La bordure peut varier avec d'autres propriétés comme "border-radius" pour arrondir les
            angles.</div>
        <p class="arron">Voici un cadre avec des angles arrondis.</p>
        <p class="rond">une boite ronde ?<br /> avec"border-radius:50%;"</p><br />
        <div class="cours">Mais, contrairement à ce qu'on observe en comparant les cadres à "hidden", le cadre fait
            partie du fond. On s'en aperçoit sur les effets de transparence. Par exemple les boites rouge et jaune ci
            dessous ont leur fond et cadre transparents de la même manière (50%). A chaque fois, le cadre apparait plus
            "foncé" car il est plus opaque. Si on pose l'ensemble sur un fond marron, les couleurs sont encore
            différentes.</div>
        <div class="boite3">voici une boite rouge transparente à 50%, réalisée avec l'élément div.<p class="boite4">Voici
                une boite jaune transparente à 50% réalisée avec l'élément p, située dans la boite rouge. Comme on
                voit, les couleurs se superposent. </p> ici c'est toujours ma boite rouge.</div>
        <div class="boite5">
            <div class="boite3">voici une boite rouge transparente à 50%, réalisée avec l'élément div.<p class="boite4">Voici
                    une boite jaune transparente à 50% réalisée avec l'élément p, située dans la boite rouge. Comme on
                    voit, les couleurs se superposent. </p> ici c'est toujours ma boite rouge.</div>
        </div>

        <div class="cours">La propriété "background-clip" spécifie l'étendue du fond. <ul>
                <li>Par défaut, la valeur "border-box" (= le fond s'applique jusqu'au bord inclu).</li>
                <li>Il faut utiliser la valeur "padding-box;" (= le fond s'applique jusqu'au padding inclu) pour avoir
                    ici des bords transparents alors que le fond est blanc opaque.</li>
                <li>La troisième valeur est "content-box" (= le fond s'applique juste au contenu).</li>
            </ul>
        </div>

        <div class="clip1">boite 1</div>
        <div class="clip2">boite 2</div>
        <div class="clip3">boite 3</div>

        <div class="grcadre">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed non risus. Suspendisse lectus
            tortor, dignissim sit amet, adipiscing nec, ultricies sed, dolor. Cras elementum ultrices diam. Maecenas
            ligula massa, varius a, semper congue, euismod non, mi. Proin porttitor, orci nec nonummy molestie, enim
            est eleifend mi, non fermentum diam nisl sit amet erat.<p class="catrans1">Avec
                "background-clip:padding-box;", on peut voir le texte sous le bord transparent de la boite. Ici, avec
                un fond blanc.</p>
        </div>



        <hr />
        <!--l'ombre des boites-->
        <h2 id="ombre">L'ombre des boites avec box-shadow</h2>
        <div class="cours">La propriété "box-shadow" va fonctionner un peu comme "text-shadow". Elle prend dans l'ordre
            5 valeurs : <ol>
                <li>le déplacement horizontal de l'ombre en pixel à droite (ou à gauche si chiffres négatifs)</li>
                <li>le déplacement vertical de l'ombre en pixel en bas (ou vers le haut si chiffres négatifs)</li>
                <li>le rayon de propagation (flou)</li>
                <li>la couleur de l'ombre</li>
                <li>éventuellement la valeur "inset" qui pose l'ombre à l'intérieur de la boite</li>
            </ol>
        </div>
        <p class="carre shadow1">ombre dehors</p>
        <p class="carre shadow2">ombre sur plusieurs cotés = ne marche pas</p>
        <p class="carre shadow3">ombre dedans</p>
        <br class="clearing" />
        <hr />
        <!--pour s'entrainer a positionner des boites-->
        <h2 id="position">Positionner des boites</h2>
        <div class="cours">Avec la propriété position. Elle peut prendre 4 valeurs possibles : <ul>
                <li>static = c'est le positionnement par défaut des éléments dans la page. Il ne sera pas affecté par
                    les valeurs de "left", "top", "rigth" et "bottom"</li>
                <li>relative = l'élément va être repositionné par rapport à sa position par défaut</li>
                <li>fixed = l'élément va rester toujour à la même place, même si on descend dans la page (utile pour
                    les menus ou sommaires)</li>
                <li>absolute = positionne un élément de façon relative à son parent le plus proche auquel on a appliqué
                    un positionnement spécifique (relative, fixed ou absolute). Cette valeur sort l'élément du flux
                    normal de la page.</li>
            </ul>La propriété "position" va être utilisée conjointement avec les propriétés "left", "top", "rigth" et
            "bottom".</div>
        <p class="carre position1">essayer les valeurs de "position"</p>
        <p class="carre position2">essayer les valeurs de "position"</p>
        <br />
        <div class="cours">en cas de chevauchement, on peut utiliser le "z-index" pour contrôler la superposition. Plus
            le chiffre est grand, plus il est dessus.</div>
        <p class="carre index1">index1</p>
        <p class="carre index2"><br /><br /><br /><br />index2</p>
        <p class="carre index3">index3</p>
        <!--<br class="absolute"/>-->
        <div class="cours">Il y a plusieurs façon d'aligner horizontalement des boites : <ul>
                <li>avec "margin" et la valeur "auto" pour la droite et la gauche</li>
                <li>avec "position" en mettant le même % dans les attributs left et right (pas propre car il faut
                    trouver le % exact</li>
                <li>avec float et ses valeurs left et right (mais pas propre non plus).</li>
            </ul>ATTENTION : "position" et "float" perturbent le flux normal de la page. Il faut faire un reset CSS des
            padding et margin sur body.</div>
        <p>à tester ici</p>


        <div class="cours">La propriété "display" va permettre de considérer les éléments inline aussi comme des blocs
            (et vice versa). Elle peut prendre la valeur :<ul>
                <li>inline = l'élément ciblé se comporte comme un élément "inline" et n'occupe que la place nécessaire</li>
                <li>block = l'élément ciblé se comporte comme un bloc</li>
                <li>inline-block = l'élément va être de type inline, mais son contenu va être de type "bloc", ce qui
                    permet de les mettre côte-à-côte.</li>
                <li>none = permet de ne pas afficher l'élément</li>
            </ul>Il y a plein d'autres valeurs.</div>
        <p>Voici un paragraphe p, donc un bloc! <span class="displayblock">dans lequel il y a un élément inline "span"</span></p>
        <span>un span tout seul</span>

        <p>Exercice : poser 4 boites en carré avec "display:inline-block". Il aligne les élements sur la dernière ligne
            de la boite précédente = décalage sur la 4eme si la 3eme fait 2 lignes.</p>
        <div class="carre" id="bhg1">boite haute à gauche</div>
        <div class="carre" id="bhd1">boite haute à droite</div><br />
        <div class="carre" id="bbg1">b. basse à gauche</div>
        <div class="carre" id="bbd1">boite basse à droite</div>

        <div class="cours">Pour poser des boites les unes à coté des autres avec float et clear</div>
        <p>Exercice : poser 4 boites en carré avec float et clear</p>
        <div class="carre" id="bhg2">
            <h5>boite haute à gauche<br />position: relative;<br />float: left;</h5>
        </div>
        <div class="carre" id="bhd2">
            <h5>boite haute à droite<br />position: relative;<br />float: left;</h5>
        </div>
        <div class="carre" id="bbg2">
            <h5>boite basse à gauche<br />position: relative;<br />clear: left;<br />float: left;</h5>
        </div>
        <div class="carre" id="bbd2">
            <h5>boite basse à droite<br />position: relative;<br />float: left;</h5>
        </div>
        <br class="clearing" />

        <div class="cours">Le modèle "flexible box" ou "flexbox" introduit la valeur flex pour display et la propriété
            "flex" (chapitre suivant). Le flexbox permet de gérer<ul>
                <li>la direction des éléments (en colonne ou en ligne, avec un retour à la ligne ou non)</li>
                <li>l'alignement des éléments selon un axe principal et secondaire ainsi que leur répartition</li>
                <li>l'ordre des éléments</li>
                <li>la place prise par les éléments en fonction de l'espace disponible.</li>
            </ul>Il faut commencer par creer un éléments conteneur (div) dans lequel on place les éléments que l'on
            veut aligner. On applique un "display:flex" et la div va se comporter comme un block. Avec
            "display:inline-flex", la div se comportera comme un élément inline. Dans les deux cas, les éléments
            contenus sont de type "flex-item".<br />
        </div>
        <p>Exercice : poser 4 boites en carré avec flex</p>
        <div class="flex">
            <p class="carre">boite haute à gauche</p>
            <p class="carre">boite haute à droite</p>
        </div>
        <div class="flex">
            <p class="carre">boite basse à gauche</p>
            <p class="carre">boite basse à droite</p>
        </div>
        <hr />
        <!--modèle flexbox-->
        <h2 id="flexbox">Le modèle flexbox et les différentes propriétés "flex"</h2>
        <div class="cours">Gérer la direction des flex-items avec "flex-direction", ce qui détermine l'axe principal
            des éléments (horizontal ou vertical) :<ul>
                <li>row (valeur par défaut) = les éléments sont organisés horizontalement</li>
                <li>row-reverse = de droite à gauche</li>
                <li>column = verticalement</li>
                <li>column-reverse = de bas en haut.</li>
            </ul>"flex-wrap" permet de définir si le contenu doit être affiché sur une seule ligne (ou colonne) ou
            plusieurs :<ul>
                <li>nowrap = les éléments ne peuvent pas passer à la ligne</li>
                <li>wrap = les élément peuvent passer à la ligne dans leur ordre de déclaration</li>
                <li>wrap-reverse = dans l'ordre inverse de leur déclaration</li>
            </ul>"flex-flow" est une compilation des deux, avec une valeur 1 (direction) et 2 (wrap).</div>

        <div class="fin flex flex1">
            <p class="box">boite 1</p>
            <p class="box">boite 2</p>
            <p class="box">boite 3</p>
            <p class="box">boite 4</p>
            <p class="box">boite 5</p>
            <p class="box">boite 6</p>
        </div>

        <div class="cours">Gérer l'organisation des éléments selon l'axe principal avec "justify-content" :<ul>
                <li>flex-start (valeur par défaut) = les éléments s'alignent en début de ligne</li>
                <li>flex-end = s'alignent en fin de ligne</li>
                <li>center = les éléments s'alignent au centre</li>
                <li>space-between = les éléments se distribuent régulièrement et collent au bord</li>
                <li>space-around = les éléments se distribuent régulièrement avec un 1/2 espace au bord</li>
                <li>space-evenly = les éléments se distribuent régulièrement avec des espaces au bord</li>
            </ul>"align-item" va gérer l'organisation sur le second axe :<ul>
                <li>stretch (défaut) = les éléments sont étirés sur l'axe</li>
                <li>flex-start = les élément sont aligné au début</li>
                <li>flex-end = sont alignés à la fin de l'axe</li>
                <li>center = sont alignés au centre</li>
                <li>baseline = les lignes de base des éléments sont alignées</li>
            </ul> suite</div>
        <div class="fin flex flex2">
            <p class="box">boite 1</p>
            <p class="box">boite 2</p>
            <p class="box">boite 3</p>
        </div>
        <hr />
        <!--transformation-->
        <h2 id="transformation">Les transformations</h2>
        <div class="cours">une transformation permet à un élément de changer de taille, de forme et de position :<ul>
                <li>"transform:rotate" fait basculer un élément (valeur en degré positif dans le sens des aiguille
                    d'une montre, négatif en contresens).</li>
                <li>"transform-origin" déplace l'élément. Valeur par défaut = 50% 50% = centre de l'élément. 0 0 =top
                    left; 100% 100% = bottom right. A utiliser avec une autre transformation.</li>
                <li>"transform:translate" bouge un élement de sa position initiale vers la droite et vers le bas (en
                    px)</li>
                <li>"transform:skew" déforme un élément sur l'axe horizontal et l'axe vertical</li>
                <li>"transform:scale" augmente ou diminue la taille d'un élement en largeur et en hauteur. 1 est la
                    taille originale. 2 = 2 fois la taille originale.</li>
            </ul>Des transformations multiples peuvent facilement être appliquées (sur la meme ligne)</div>
        <p class="box rotate">"transform:rotate"</p>
        <p class="box origin">"transform-origin"</p>
        <p class="box translate">"transform:translate"</p>
        <p class="box skew">"transform:skew"</p>
        <p class="box scale">"transform:scale"</p>
        <div class="cours">Les transformations 3D sont similaires aux 2D, en introduisant l'axe Z (en plus des axes X
            et Y. Exemples avec rotate.</div>
        <p class="box rotateX">rotateX</p>
        <p class="box rotateY">rotateY</p>
        <p class="box rotateZ">rotateZ</p>
        <div class="etoiles">
            <div class="episode"> Episode IV<br />Un nouvel espoir</div>
        </div>
        <br />
        <hr />
        <!--transition-->
        <h2 id="transition">Les transitions</h2>
        <div class="cours">"Transition" permet de modifier des propriétés dans le temps. Pour fonctionner, il faut
            indiquer un changement de valeur (par exemple la pseudo-class ":hover"). Elle comprend : <ul>
                <li>"transition-delay" indique quand doit commencer la transition.</li>
                <li>"transition-duration" indique la durée de la transition.</li>
                <li>"transition-property" définie la propriété à laquelle la transition s'applique.</li>
                <li>"transition-timing-function" définit la courbe de vitesse de la transition.</li>
            </ul> Elle peuvent être regroupées sous une seule "transition" pour laquelle seule duration et property
            sont obligatoires.<br />Les transitions sont récentes : utiliser les préfixes "vendeurs" pour qu'elles
            soient reconnues par tous les navigateurs.</div>
        <p class="box move1">transition:width</p>
        <div class="cours">"Transition-timing-function" prend différentes valeurs : <ul>
                <li>"ease" commence doucement et accélère vite</li>
                <li>"ease-in" débute doucement , puis accélère vite</li>
                <li>"ease-out" débute vite, mais décélère jusqu'au stop</li>
                <li>"ease-in-out" /définit la courbe de vitesse de la transition//ease en plus subtile.</li>
                <li>"linear" constant (le mieux pour changer de couleur</li>
                <li>"cubic-bezier()" pour définir nos propres valeurs.
            </ul>
        </div>
        <p class="ease box">ease</p>
        <p class="ease-in box">ease-in</p>
        <p class="ease-out box">ease-out</p>
        <p class="ease-in-out box">ease-in-out</p>
        <p class="linear box">linear</p>
        <p class="cubic-bezier1 box">cubic-bezier1</p>
        <p class="cubic-bezier2 box">cubic-bezier2</p>
        <!--les animations-->
        <h2 id="animation">Les animations</h2>
        <div class="cours">Les animations permettent de changer le style d'un élément sans changement d'état de
            celui-ci, et autant de fois que l'on veut. Pour créer une animation, il faut utiliser :<ul>
                <li>la propriété "animation" :</li>
                <ul>
                    <li>"animation-name" = nom de l'animation qu'on réutilisara dans la déclaration de @keyframes
                        (obligatoire)</li>
                    <li>"animation duration" : durée de l'animation en seconde (obligatoire)</li>
                    <li>"animation-timing-function" = courbe de vitesse de l'animation (mêmes valeurs que pour les
                        transitions)</li>
                    <li>"animation-delay" délai avant le départ de l'animaion</li>
                    <li>"animation-iteration-count" = nombre de fois que l'animation doit être jouée (nbr, ou
                        "infinite" </li>
                    <li>"animation-direction" spécifie si l'animation doit se jouer à l'envers ou selon des cycles
                        alternés avec avec les valeurs "normal" (par défaut), "reverse", "alternate" et "alternate
                        reverse";</li>
                </ul>
                <li>la règle CSS "@keyframes" pour donner un nom à l'animation</li>
            </ul>Les animations sont récentes : utiliser les préfixes "vendeurs" pour qu'elles soient reconnues par
            tous les navigateurs. Internet explorer avant version 10 ne les reconnait pas. ATTENTION, la notation
            shorthand "animation : name duration" n'est pas toujours bien supportée par les navigateurs.</div>
        <p class="anim1">changement de couleur simple</p>
        <p class="anim2">autre</p>
        <p><img class="anim3" src="Images/cat.jpg"></p>
    </article>
    <aside>
    </aside>
    <footer>
    </footer>
</body>

</html>
